;*****************************************************************************
;*
;* This program is free software ; you can redistribute it and/or modify
;* it under the terms of the GNU General Public License as published by
;* the Free Software Foundation; either version 2 of the License, or
;* (at your option) any later version.
;*
;* This program is distributed in the hope that it will be useful,
;* but WITHOUT ANY WARRANTY; without even the implied warranty of
;* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;* GNU General Public License for more details.
;*
;* You should have received a copy of the GNU General Public License
;* along with this program; if not, write to the Free Software
;* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
;*
;* $Id$
;*
;*****************************************************************************

	AREA	|.text|, CODE

	EXPORT IsDMAReady
	EXPORT Draw
	IMPORT _IsDMAReady

IsDMAReady PROC
   
	stmdb   sp!,{r4 - r12,lr}
	mov r0,sp
	ldr r12,AddrIsDMAReady
	mov lr,pc
	mov pc,r12
	ldmia sp!,{r4 - r12, pc}  

AddrIsDMAReady dcd _IsDMAReady

; r0 src
; r1 dest
; r2 dest pitch
; r3 height

Draw PROC
		
	stmdb   sp!,{r4 - r12,lr}
	mov	 r8,r2
	mov  r4,r0
	mov  r10,r1
	mov  r9,r3

LoopY
    add	 r7,r4,#480
	mov  r5,r10
	add	 r6,r10,r8

	ldr  r0,[r4,#0x000]
	ldr  r1,[r4,#0x010]
	ldr  r2,[r4,#0x020]
	ldr  r3,[r4,#0x030]
	ldr  r0,[r4,#0x040]
	ldr  r1,[r4,#0x060]
	ldr  r2,[r4,#0x070]
	ldr  r3,[r4,#0x080]
	ldr  r0,[r4,#0x090]
	ldr  r1,[r4,#0x0A0]
	ldr  r2,[r4,#0x0B0]
	ldr  r3,[r4,#0x0C0]
	ldr  r0,[r4,#0x0D0]
	ldr  r1,[r4,#0x0E0]
	ldr  r2,[r4,#0x0F0]
	ldr  r3,[r4,#0x100]
	ldr  r0,[r4,#0x110]
	ldr  r1,[r4,#0x120]
	ldr  r2,[r4,#0x130]
	ldr  r3,[r4,#0x140]
	ldr  r0,[r4,#0x150]
	ldr  r1,[r4,#0x160]
	ldr  r2,[r4,#0x170]
	ldr  r3,[r4,#0x180]
	ldr  r0,[r4,#0x190]
	ldr  r1,[r4,#0x1A0]
	ldr  r2,[r4,#0x1B0]
	ldr  r3,[r4,#0x1C0]
	ldr  r0,[r4,#0x1D0]

LoopX	
	ldrh r0,[r4],#2
	ldrh r1,[r4],#2
	ldrh r2,[r4],#2
	ldrh r3,[r4],#2
	add	 r0,r0,r0,lsl #16
	add	 r1,r1,r1,lsl #16
	add	 r2,r2,r2,lsl #16
	add	 r3,r3,r3,lsl #16
	str	 r0,[r5],#4
	str	 r1,[r5],#4
	str	 r2,[r5],#4
	str	 r3,[r5],#4
	str	 r0,[r6],#4
	str	 r1,[r6],#4
	str	 r2,[r6],#4
	str	 r3,[r6],#4

	ldrh r0,[r4],#2
	ldrh r1,[r4],#2
	ldrh r2,[r4],#2
	ldrh r3,[r4],#2
	add	 r0,r0,r0,lsl #16
	add	 r1,r1,r1,lsl #16
	add	 r2,r2,r2,lsl #16
	add	 r3,r3,r3,lsl #16
	str	 r0,[r5],#4
	str	 r1,[r5],#4
	str	 r2,[r5],#4
	str	 r3,[r5],#4
	str	 r0,[r6],#4
	str	 r1,[r6],#4
	str	 r2,[r6],#4
	str	 r3,[r6],#4

	cmp	 r4,r7
	bne	 LoopX

    add  r10,r10,r8,lsl #1
	subs r9,r9,#1
	bne  LoopY

	ldmia sp!,{r4 - r12, pc}  

	ENDP
	END
